/* archive-reader.c generated by valac 0.40.19, the Vala compiler
 * generated from archive-reader.vala, do not modify */

/* This file is part of GNOME Boxes. License: LGPLv2+*/


#include <glib.h>
#include <glib-object.h>
#include <archive.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <archive_entry.h>
#include "common.h"
#include <stdio.h>
#include <glib/gstdio.h>


#define BOXES_TYPE_ARCHIVE_READER (boxes_archive_reader_get_type ())
#define BOXES_ARCHIVE_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_ARCHIVE_READER, BoxesArchiveReader))
#define BOXES_ARCHIVE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BOXES_TYPE_ARCHIVE_READER, BoxesArchiveReaderClass))
#define BOXES_IS_ARCHIVE_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_ARCHIVE_READER))
#define BOXES_IS_ARCHIVE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BOXES_TYPE_ARCHIVE_READER))
#define BOXES_ARCHIVE_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BOXES_TYPE_ARCHIVE_READER, BoxesArchiveReaderClass))

typedef struct _BoxesArchiveReader BoxesArchiveReader;
typedef struct _BoxesArchiveReaderClass BoxesArchiveReaderClass;
typedef struct _BoxesArchiveReaderPrivate BoxesArchiveReaderPrivate;
enum  {
	BOXES_ARCHIVE_READER_0_PROPERTY,
	BOXES_ARCHIVE_READER_NUM_PROPERTIES
};
static GParamSpec* boxes_archive_reader_properties[BOXES_ARCHIVE_READER_NUM_PROPERTIES];
#define _archive_read_finish0(var) ((var == NULL) ? NULL : (var = (archive_read_finish (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block14Data Block14Data;
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
typedef struct _Block15Data Block15Data;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _BoxesArchiveReader {
	GObject parent_instance;
	BoxesArchiveReaderPrivate * priv;
	struct archive* archive;
};

struct _BoxesArchiveReaderClass {
	GObjectClass parent_class;
};

struct _BoxesArchiveReaderPrivate {
	gchar* filename;
	int* format;
	GList* filters;
};

struct _Block14Data {
	int _ref_count_;
	BoxesArchiveReader* self;
	FILE* fd;
};

struct _Block15Data {
	int _ref_count_;
	BoxesArchiveReader* self;
	int filter;
};


static gpointer boxes_archive_reader_parent_class = NULL;

GType boxes_archive_reader_get_type (void) G_GNUC_CONST;
#define BOXES_ARCHIVE_READER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), BOXES_TYPE_ARCHIVE_READER, BoxesArchiveReaderPrivate))
#define BOXES_ARCHIVE_READER_BLOCK_SIZE 10240
BoxesArchiveReader* boxes_archive_reader_new (const gchar* filename,
                                              int* format,
                                              GList* filters,
                                              GError** error);
BoxesArchiveReader* boxes_archive_reader_construct (GType object_type,
                                                    const gchar* filename,
                                                    int* format,
                                                    GList* filters,
                                                    GError** error);
static int* _archive_format_dup (int* self);
static void boxes_archive_reader_open_archive (BoxesArchiveReader* self,
                                        GError** error);
GList* boxes_archive_reader_get_file_list (BoxesArchiveReader* self,
                                           GError** error);
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
void boxes_archive_reader_extract_file (BoxesArchiveReader* self,
                                        const gchar* src,
                                        const gchar* dest,
                                        gboolean override_if_necessary,
                                        GError** error);
static void boxes_archive_reader_extract_files_recursive (BoxesArchiveReader* self,
                                                   gchar** src_list,
                                                   int src_list_length1,
                                                   gchar** dest_list,
                                                   int dest_list_length1,
                                                   gboolean override_if_necessary,
                                                   gboolean follow_hardlinks,
                                                   GError** error);
void boxes_archive_reader_reset (BoxesArchiveReader* self,
                                 GError** error);
static int _archive_read_close_boxes_libarchive_function (gpointer self);
static Block14Data* block14_data_ref (Block14Data* _data14_);
static void block14_data_unref (void * _userdata_);
static gchar* boxes_archive_reader_get_dest_file (BoxesArchiveReader* self,
                                           gchar** src_list,
                                           int src_list_length1,
                                           gchar** dest_list,
                                           int dest_list_length1,
                                           const gchar* src);
static int _archive_read_data_skip_boxes_libarchive_function (gpointer self);
static void _vala_array_add1 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static int ___lambda33_ (Block14Data* _data14_);
static int ____lambda33__boxes_libarchive_function (gpointer self);
static int _archive_read_support_format_all_boxes_libarchive_function (gpointer self);
static int ___lambda30_ (BoxesArchiveReader* self);
static int ____lambda30__boxes_libarchive_function (gpointer self);
static int _archive_read_support_filter_all_boxes_libarchive_function (gpointer self);
static Block15Data* block15_data_ref (Block15Data* _data15_);
static void block15_data_unref (void * _userdata_);
static int _____lambda31_ (Block15Data* _data15_);
static int ______lambda31__boxes_libarchive_function (gpointer self);
static int __lambda32_ (BoxesArchiveReader* self);
static int ___lambda32__boxes_libarchive_function (gpointer self);
static void boxes_archive_reader_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


static int*
_archive_format_dup (int* self)
{
	int* dup;
	dup = g_new0 (int, 1);
	memcpy (dup, self, sizeof (int));
	return dup;
}


static gpointer
__archive_format_dup0 (gpointer self)
{
	return self ? _archive_format_dup (self) : NULL;
}


BoxesArchiveReader*
boxes_archive_reader_construct (GType object_type,
                                const gchar* filename,
                                int* format,
                                GList* filters,
                                GError** error)
{
	BoxesArchiveReader * self = NULL;
	gchar* _tmp0_;
	int* _tmp1_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (filename != NULL, NULL);
	self = (BoxesArchiveReader*) g_object_new (object_type, NULL);
	_tmp0_ = g_strdup (filename);
	_g_free0 (self->priv->filename);
	self->priv->filename = _tmp0_;
	_tmp1_ = __archive_format_dup0 (format);
	_g_free0 (self->priv->format);
	self->priv->format = _tmp1_;
	if (filters != NULL) {
		GList* _tmp2_;
		_tmp2_ = g_list_copy (filters);
		(self->priv->filters == NULL) ? NULL : (self->priv->filters = (g_list_free (self->priv->filters), NULL));
		self->priv->filters = _tmp2_;
	}
	boxes_archive_reader_open_archive (self, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (self);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	return self;
}


BoxesArchiveReader*
boxes_archive_reader_new (const gchar* filename,
                          int* format,
                          GList* filters,
                          GError** error)
{
	return boxes_archive_reader_construct (BOXES_TYPE_ARCHIVE_READER, filename, format, filters, error);
}


static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}


static inline void
_g_list_free__g_free0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
}


GList*
boxes_archive_reader_get_file_list (BoxesArchiveReader* self,
                                    GError** error)
{
	GList* result = NULL;
	GList* _result_ = NULL;
	struct archive_entry* iterator = NULL;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_result_ = NULL;
	while (TRUE) {
		gboolean _tmp0_ = FALSE;
		struct archive* _tmp1_;
		struct archive_entry* _tmp2_ = NULL;
		gboolean _tmp3_;
		struct archive_entry* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp1_ = self->archive;
		_tmp3_ = boxes_get_next_header (_tmp1_, &_tmp2_, (guint) 1, &_inner_error0_);
		iterator = _tmp2_;
		_tmp0_ = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_IO_ERROR) {
				g_propagate_error (error, _inner_error0_);
				(_result_ == NULL) ? NULL : (_result_ = (_g_list_free__g_free0_ (_result_), NULL));
				return NULL;
			} else {
				(_result_ == NULL) ? NULL : (_result_ = (_g_list_free__g_free0_ (_result_), NULL));
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		if (!_tmp0_) {
			break;
		}
		_tmp4_ = iterator;
		_tmp5_ = archive_entry_pathname (_tmp4_);
		_tmp6_ = g_strdup (_tmp5_);
		_result_ = g_list_append (_result_, _tmp6_);
	}
	result = _result_;
	return result;
}


void
boxes_archive_reader_extract_file (BoxesArchiveReader* self,
                                   const gchar* src,
                                   const gchar* dest,
                                   gboolean override_if_necessary,
                                   GError** error)
{
	gchar* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (src != NULL);
	g_return_if_fail (dest != NULL);
	_tmp0_ = g_strdup (src);
	_tmp1_ = g_new0 (gchar*, 1 + 1);
	_tmp1_[0] = _tmp0_;
	_tmp2_ = _tmp1_;
	_tmp2__length1 = 1;
	_tmp3_ = g_strdup (dest);
	_tmp4_ = g_new0 (gchar*, 1 + 1);
	_tmp4_[0] = _tmp3_;
	_tmp5_ = _tmp4_;
	_tmp5__length1 = 1;
	boxes_archive_reader_extract_files_recursive (self, _tmp2_, 1, _tmp5_, 1, override_if_necessary, TRUE, &_inner_error0_);
	_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}


static int
_archive_read_close_boxes_libarchive_function (gpointer self)
{
	int result;
	result = archive_read_close ((struct archive*) self);
	return result;
}


void
boxes_archive_reader_reset (BoxesArchiveReader* self,
                            GError** error)
{
	struct archive* _tmp0_;
	struct archive* _tmp1_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->archive;
	_tmp1_ = self->archive;
	boxes_execute_libarchive_function (_tmp0_, _archive_read_close_boxes_libarchive_function, _tmp1_, (guint) 1, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	boxes_archive_reader_open_archive (self, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}


static Block14Data*
block14_data_ref (Block14Data* _data14_)
{
	g_atomic_int_inc (&_data14_->_ref_count_);
	return _data14_;
}


static void
block14_data_unref (void * _userdata_)
{
	Block14Data* _data14_;
	_data14_ = (Block14Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data14_->_ref_count_)) {
		BoxesArchiveReader* self;
		self = _data14_->self;
		_fclose0 (_data14_->fd);
		_g_object_unref0 (self);
		g_slice_free (Block14Data, _data14_);
	}
}


static int
_archive_read_data_skip_boxes_libarchive_function (gpointer self)
{
	int result;
	result = archive_read_data_skip ((struct archive*) self);
	return result;
}


static void
_vala_array_add1 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void
_vala_array_add2 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static int
___lambda33_ (Block14Data* _data14_)
{
	BoxesArchiveReader* self;
	int result = 0;
	struct archive* _tmp0_;
	FILE* _tmp1_;
	self = _data14_->self;
	_tmp0_ = self->archive;
	_tmp1_ = _data14_->fd;
	result = archive_read_data_into_fd (_tmp0_, fileno (_tmp1_));
	return result;
}


static int
____lambda33__boxes_libarchive_function (gpointer self)
{
	int result;
	result = ___lambda33_ (self);
	return result;
}


static void
boxes_archive_reader_extract_files_recursive (BoxesArchiveReader* self,
                                              gchar** src_list,
                                              int src_list_length1,
                                              gchar** dest_list,
                                              int dest_list_length1,
                                              gboolean override_if_necessary,
                                              gboolean follow_hardlinks,
                                              GError** error)
{
	struct archive_entry* iterator = NULL;
	guint i = 0U;
	gchar** hardlink_src = NULL;
	gchar** _tmp0_;
	gint hardlink_src_length1;
	gint _hardlink_src_size_;
	gchar** hardlink_dest = NULL;
	gchar** _tmp1_;
	gint hardlink_dest_length1;
	gint _hardlink_dest_size_;
	guint _tmp40_;
	gchar** _tmp42_;
	gint _tmp42__length1;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_vala_return_if_fail (src_list_length1 == dest_list_length1, "src_list.length == dest_list.length");
	if (src_list_length1 == 0) {
		return;
	}
	i = (guint) 0;
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	hardlink_src = _tmp0_;
	hardlink_src_length1 = 0;
	_hardlink_src_size_ = hardlink_src_length1;
	_tmp1_ = g_new0 (gchar*, 0 + 1);
	hardlink_dest = _tmp1_;
	hardlink_dest_length1 = 0;
	_hardlink_dest_size_ = hardlink_dest_length1;
	while (TRUE) {
		Block14Data* _data14_;
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		struct archive* _tmp4_;
		struct archive_entry* _tmp5_ = NULL;
		gboolean _tmp6_;
		gchar* dest = NULL;
		struct archive_entry* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		gboolean _tmp14_ = FALSE;
		struct archive_entry* _tmp15_;
		const gchar* _tmp16_;
		gboolean _tmp30_ = FALSE;
		const gchar* _tmp34_;
		FILE* _tmp35_;
		struct archive* _tmp36_;
		const gchar* _tmp37_;
		const gchar* _tmp38_;
		guint _tmp39_;
		_data14_ = g_slice_new0 (Block14Data);
		_data14_->_ref_count_ = 1;
		_data14_->self = g_object_ref (self);
		_tmp4_ = self->archive;
		_tmp6_ = boxes_get_next_header (_tmp4_, &_tmp5_, (guint) 1, &_inner_error0_);
		iterator = _tmp5_;
		_tmp3_ = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_IO_ERROR) {
				g_propagate_error (error, _inner_error0_);
				block14_data_unref (_data14_);
				_data14_ = NULL;
				hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
				hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
				return;
			} else {
				block14_data_unref (_data14_);
				_data14_ = NULL;
				hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
				hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		if (_tmp3_) {
			guint _tmp7_;
			_tmp7_ = i;
			_tmp2_ = _tmp7_ < ((guint) src_list_length1);
		} else {
			_tmp2_ = FALSE;
		}
		if (!_tmp2_) {
			block14_data_unref (_data14_);
			_data14_ = NULL;
			break;
		}
		_tmp8_ = iterator;
		_tmp9_ = archive_entry_pathname (_tmp8_);
		_tmp10_ = boxes_archive_reader_get_dest_file (self, src_list, src_list_length1, dest_list, dest_list_length1, _tmp9_);
		dest = _tmp10_;
		_tmp11_ = dest;
		if (_tmp11_ == NULL) {
			struct archive* _tmp12_;
			struct archive* _tmp13_;
			_tmp12_ = self->archive;
			_tmp13_ = self->archive;
			boxes_execute_libarchive_function (_tmp12_, _archive_read_data_skip_boxes_libarchive_function, _tmp13_, (guint) 1, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == G_IO_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_g_free0 (dest);
					block14_data_unref (_data14_);
					_data14_ = NULL;
					hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
					hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
					return;
				} else {
					_g_free0 (dest);
					block14_data_unref (_data14_);
					_data14_ = NULL;
					hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
					hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			_g_free0 (dest);
			block14_data_unref (_data14_);
			_data14_ = NULL;
			continue;
		}
		_tmp15_ = iterator;
		_tmp16_ = archive_entry_hardlink (_tmp15_);
		if (_tmp16_ != NULL) {
			struct archive_entry* _tmp17_;
			_tmp17_ = iterator;
			_tmp14_ = archive_entry_size (_tmp17_) == ((gint64) 0);
		} else {
			_tmp14_ = FALSE;
		}
		if (_tmp14_) {
			struct archive_entry* _tmp18_;
			const gchar* _tmp19_;
			struct archive_entry* _tmp20_;
			const gchar* _tmp21_;
			gchar** _tmp22_;
			gint _tmp22__length1;
			struct archive_entry* _tmp23_;
			const gchar* _tmp24_;
			gchar* _tmp25_;
			gchar** _tmp26_;
			gint _tmp26__length1;
			const gchar* _tmp27_;
			gchar* _tmp28_;
			guint _tmp29_;
			_tmp18_ = iterator;
			_tmp19_ = archive_entry_pathname (_tmp18_);
			_tmp20_ = iterator;
			_tmp21_ = archive_entry_hardlink (_tmp20_);
			g_debug ("archive-reader.vala:72: Following hardlink of '%s' to '%s'.", _tmp19_, _tmp21_);
			_tmp22_ = hardlink_src;
			_tmp22__length1 = hardlink_src_length1;
			_tmp23_ = iterator;
			_tmp24_ = archive_entry_hardlink (_tmp23_);
			_tmp25_ = g_strdup (_tmp24_);
			_vala_array_add1 (&hardlink_src, &hardlink_src_length1, &_hardlink_src_size_, _tmp25_);
			_tmp26_ = hardlink_dest;
			_tmp26__length1 = hardlink_dest_length1;
			_tmp27_ = dest;
			_tmp28_ = g_strdup (_tmp27_);
			_vala_array_add2 (&hardlink_dest, &hardlink_dest_length1, &_hardlink_dest_size_, _tmp28_);
			_tmp29_ = i;
			i = _tmp29_ + 1;
			_g_free0 (dest);
			block14_data_unref (_data14_);
			_data14_ = NULL;
			continue;
		}
		if (!override_if_necessary) {
			const gchar* _tmp31_;
			_tmp31_ = dest;
			_tmp30_ = g_file_test (_tmp31_, G_FILE_TEST_EXISTS);
		} else {
			_tmp30_ = FALSE;
		}
		if (_tmp30_) {
			const gchar* _tmp32_;
			GError* _tmp33_;
			_tmp32_ = dest;
			_tmp33_ = g_error_new (G_IO_ERROR, G_IO_ERROR_EXISTS, "Destination file '%s' already exists.", _tmp32_);
			_inner_error0_ = _tmp33_;
			if (_inner_error0_->domain == G_IO_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (dest);
				block14_data_unref (_data14_);
				_data14_ = NULL;
				hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
				hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
				return;
			} else {
				_g_free0 (dest);
				block14_data_unref (_data14_);
				_data14_ = NULL;
				hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
				hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_tmp34_ = dest;
		_tmp35_ = g_fopen (_tmp34_, "w+");
		_data14_->fd = _tmp35_;
		_tmp36_ = self->archive;
		boxes_execute_libarchive_function (_tmp36_, ____lambda33__boxes_libarchive_function, _data14_, (guint) 1, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_IO_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (dest);
				block14_data_unref (_data14_);
				_data14_ = NULL;
				hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
				hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
				return;
			} else {
				_g_free0 (dest);
				block14_data_unref (_data14_);
				_data14_ = NULL;
				hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
				hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_tmp37_ = dest;
		_tmp38_ = self->priv->filename;
		g_debug ("archive-reader.vala:87: Extracted file '%s' from archive '%s'.", _tmp37_, _tmp38_);
		_tmp39_ = i;
		i = _tmp39_ + 1;
		_g_free0 (dest);
		block14_data_unref (_data14_);
		_data14_ = NULL;
	}
	_tmp40_ = i;
	if (((guint) src_list_length1) != _tmp40_) {
		GError* _tmp41_;
		_tmp41_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_FOUND, "At least one specified file was not found in the archive.");
		_inner_error0_ = _tmp41_;
		if (_inner_error0_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error0_);
			hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
			hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
			return;
		} else {
			hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
			hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	boxes_archive_reader_reset (self, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error0_);
			hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
			hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
			return;
		} else {
			hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
			hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp42_ = hardlink_src;
	_tmp42__length1 = hardlink_src_length1;
	if (_tmp42__length1 > 0) {
		if (follow_hardlinks) {
			gchar** _tmp43_;
			gint _tmp43__length1;
			gchar** _tmp44_;
			gint _tmp44__length1;
			_tmp43_ = hardlink_src;
			_tmp43__length1 = hardlink_src_length1;
			_tmp44_ = hardlink_dest;
			_tmp44__length1 = hardlink_dest_length1;
			boxes_archive_reader_extract_files_recursive (self, _tmp43_, _tmp43__length1, _tmp44_, _tmp44__length1, override_if_necessary, FALSE, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == G_IO_ERROR) {
					g_propagate_error (error, _inner_error0_);
					hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
					hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
					return;
				} else {
					hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
					hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
		} else {
			gchar* msg = NULL;
			gchar* _tmp45_;
			const gchar* _tmp46_;
			GError* _tmp47_;
			_tmp45_ = g_strdup ("Maximum recursion depth exceeded. It is likely that a hardlink points " \
"to itself.");
			msg = _tmp45_;
			_tmp46_ = msg;
			_tmp47_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_WOULD_RECURSE, _tmp46_);
			_inner_error0_ = _tmp47_;
			if (_inner_error0_->domain == G_IO_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
				hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
				return;
			} else {
				_g_free0 (msg);
				hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
				hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
			_g_free0 (msg);
		}
	}
	hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
	hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
}


static gchar*
boxes_archive_reader_get_dest_file (BoxesArchiveReader* self,
                                    gchar** src_list,
                                    int src_list_length1,
                                    gchar** dest_list,
                                    int dest_list_length1,
                                    const gchar* src)
{
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (src != NULL, NULL);
	{
		guint j = 0U;
		j = (guint) 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				guint _tmp2_;
				guint _tmp3_;
				const gchar* _tmp4_;
				if (!_tmp0_) {
					guint _tmp1_;
					_tmp1_ = j;
					j = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = j;
				if (!(_tmp2_ < ((guint) src_list_length1))) {
					break;
				}
				_tmp3_ = j;
				_tmp4_ = src_list[_tmp3_];
				if (g_strcmp0 (_tmp4_, src) == 0) {
					guint _tmp5_;
					const gchar* _tmp6_;
					gchar* _tmp7_;
					_tmp5_ = j;
					_tmp6_ = dest_list[_tmp5_];
					_tmp7_ = g_strdup (_tmp6_);
					result = _tmp7_;
					return result;
				}
			}
		}
	}
	result = NULL;
	return result;
}


static int
_archive_read_support_format_all_boxes_libarchive_function (gpointer self)
{
	int result;
	result = archive_read_support_format_all ((struct archive*) self);
	return result;
}


static int
___lambda30_ (BoxesArchiveReader* self)
{
	int result = 0;
	struct archive* _tmp0_;
	int* _tmp1_;
	_tmp0_ = self->archive;
	_tmp1_ = self->priv->format;
	result = archive_read_set_format (_tmp0_, *_tmp1_);
	return result;
}


static int
____lambda30__boxes_libarchive_function (gpointer self)
{
	int result;
	result = ___lambda30_ ((BoxesArchiveReader*) self);
	return result;
}


static int
_archive_read_support_filter_all_boxes_libarchive_function (gpointer self)
{
	int result;
	result = archive_read_support_filter_all ((struct archive*) self);
	return result;
}


static Block15Data*
block15_data_ref (Block15Data* _data15_)
{
	g_atomic_int_inc (&_data15_->_ref_count_);
	return _data15_;
}


static void
block15_data_unref (void * _userdata_)
{
	Block15Data* _data15_;
	_data15_ = (Block15Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data15_->_ref_count_)) {
		BoxesArchiveReader* self;
		self = _data15_->self;
		_g_object_unref0 (self);
		g_slice_free (Block15Data, _data15_);
	}
}


static int
_____lambda31_ (Block15Data* _data15_)
{
	BoxesArchiveReader* self;
	int result = 0;
	struct archive* _tmp0_;
	int _tmp1_;
	self = _data15_->self;
	_tmp0_ = self->archive;
	_tmp1_ = _data15_->filter;
	result = archive_read_append_filter (_tmp0_, _tmp1_);
	return result;
}


static int
______lambda31__boxes_libarchive_function (gpointer self)
{
	int result;
	result = _____lambda31_ (self);
	return result;
}


static int
__lambda32_ (BoxesArchiveReader* self)
{
	int result = 0;
	struct archive* _tmp0_;
	const gchar* _tmp1_;
	_tmp0_ = self->archive;
	_tmp1_ = self->priv->filename;
	result = archive_read_open_filename (_tmp0_, _tmp1_, (gsize) BOXES_ARCHIVE_READER_BLOCK_SIZE);
	return result;
}


static int
___lambda32__boxes_libarchive_function (gpointer self)
{
	int result;
	result = __lambda32_ ((BoxesArchiveReader*) self);
	return result;
}


static void
boxes_archive_reader_open_archive (BoxesArchiveReader* self,
                                   GError** error)
{
	struct archive* _tmp0_;
	int* _tmp1_;
	GList* _tmp5_;
	struct archive* _tmp10_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = archive_read_new ();
	_archive_read_finish0 (self->archive);
	self->archive = _tmp0_;
	_tmp1_ = self->priv->format;
	if (_tmp1_ == NULL) {
		struct archive* _tmp2_;
		struct archive* _tmp3_;
		_tmp2_ = self->archive;
		_tmp3_ = self->archive;
		boxes_execute_libarchive_function (_tmp2_, _archive_read_support_format_all_boxes_libarchive_function, _tmp3_, (guint) 1, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_IO_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	} else {
		struct archive* _tmp4_;
		_tmp4_ = self->archive;
		boxes_execute_libarchive_function (_tmp4_, ____lambda30__boxes_libarchive_function, self, (guint) 1, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_IO_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	_tmp5_ = self->priv->filters;
	if (_tmp5_ == NULL) {
		struct archive* _tmp6_;
		struct archive* _tmp7_;
		_tmp6_ = self->archive;
		_tmp7_ = self->archive;
		boxes_execute_libarchive_function (_tmp6_, _archive_read_support_filter_all_boxes_libarchive_function, _tmp7_, (guint) 1, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_IO_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	} else {
		GList* _tmp8_;
		_tmp8_ = self->priv->filters;
		{
			GList* filter_collection = NULL;
			GList* filter_it = NULL;
			filter_collection = _tmp8_;
			for (filter_it = filter_collection; filter_it != NULL; filter_it = filter_it->next) {
				int filter = 0;
				filter = (int) ((gintptr) filter_it->data);
				{
					Block15Data* _data15_;
					struct archive* _tmp9_;
					_data15_ = g_slice_new0 (Block15Data);
					_data15_->_ref_count_ = 1;
					_data15_->self = g_object_ref (self);
					_data15_->filter = filter;
					_tmp9_ = self->archive;
					boxes_execute_libarchive_function (_tmp9_, ______lambda31__boxes_libarchive_function, _data15_, (guint) 1, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						if (_inner_error0_->domain == G_IO_ERROR) {
							g_propagate_error (error, _inner_error0_);
							block15_data_unref (_data15_);
							_data15_ = NULL;
							return;
						} else {
							block15_data_unref (_data15_);
							_data15_ = NULL;
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return;
						}
					}
					block15_data_unref (_data15_);
					_data15_ = NULL;
				}
			}
		}
	}
	_tmp10_ = self->archive;
	boxes_execute_libarchive_function (_tmp10_, ___lambda32__boxes_libarchive_function, self, (guint) 1, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}


static void
boxes_archive_reader_class_init (BoxesArchiveReaderClass * klass)
{
	boxes_archive_reader_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (BoxesArchiveReaderPrivate));
	G_OBJECT_CLASS (klass)->finalize = boxes_archive_reader_finalize;
}


static void
boxes_archive_reader_instance_init (BoxesArchiveReader * self)
{
	self->priv = BOXES_ARCHIVE_READER_GET_PRIVATE (self);
}


static void
boxes_archive_reader_finalize (GObject * obj)
{
	BoxesArchiveReader * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BOXES_TYPE_ARCHIVE_READER, BoxesArchiveReader);
	_archive_read_finish0 (self->archive);
	_g_free0 (self->priv->filename);
	_g_free0 (self->priv->format);
	(self->priv->filters == NULL) ? NULL : (self->priv->filters = (g_list_free (self->priv->filters), NULL));
	G_OBJECT_CLASS (boxes_archive_reader_parent_class)->finalize (obj);
}


GType
boxes_archive_reader_get_type (void)
{
	static volatile gsize boxes_archive_reader_type_id__volatile = 0;
	if (g_once_init_enter (&boxes_archive_reader_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BoxesArchiveReaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) boxes_archive_reader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BoxesArchiveReader), 0, (GInstanceInitFunc) boxes_archive_reader_instance_init, NULL };
		GType boxes_archive_reader_type_id;
		boxes_archive_reader_type_id = g_type_register_static (G_TYPE_OBJECT, "BoxesArchiveReader", &g_define_type_info, 0);
		g_once_init_leave (&boxes_archive_reader_type_id__volatile, boxes_archive_reader_type_id);
	}
	return boxes_archive_reader_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



